%- Model B
%---Everything above line 32 are initial values and can be changed.
clear;
h = 0.025;          % Step i x-direction
T = 50;             % Time steps
q =.70;             % Right of way parameter for roads junctions with 2 incomming and 1 outgoing roads.
alpha =.5;          % Procentage of cars from big roads to big roads in junctions with 1 incomming and 2 outgoing. (where there are 3 big)
alpha1 = .70;       % Procentage of cars from big roads to big roads in junctions with 1 incomming and 2 outgoing. (2 big,1 small)
alpha2 = .30;       % Procentage of cars from big roads to small roads in junctions with 1 incomming and 2 outging.(2 big,1 small)
%-------- Initial values of the 17 roads
u1=   0;%.45;
u2=   0;%.5;
u3=   0;%.45;
u4=   0;%.5;
u5=   0;%.5;
u6=   0;%.7;
u7=   0;%.55;
u8=   0;%.3;
u9=   0;%.5;
u10=  0;%.5;
u11 = 0;%1;
u12 = 0;%.5;
u13 = 0;%.45;
%--"sideroads"--
us1 = 0;%.25;
us2 = 0;%0;
us3 = 0;%0;
us4 = 0;%.25;
%---- Flux on the 2 incomming roads.
u13b = .5;%0.15;
u7b = .5;%0.25;
%------------------------------
k = h;             % length of timestep
x = h:h:1;         % Points of the roads
Nx = length(x);    % number of steps in x-direction
t = floor(T/k);    % number of steps in t-direction
%starting flux on the roads. (F1 is road 1 etc.)
F1(1,1:Nx) = u1;
F2(1,1:Nx) = u2;
F3(1,1:Nx) = u3;
F4(1,1:Nx) = u4;
F5(1,1:Nx) = u5;
F6(1,1:Nx) = u6;
F7(1,1:Nx) = u7;
F8(1,1:Nx) = u8;
F9(1,1:Nx) = u9;
F10(1,1:Nx) = u10;
F11(1,1:Nx) = u11;
F12(1,1:Nx) = u12;
F13(1,1:Nx) = u13;
Fs1(1,1:Nx) = us1;
Fs2(1,1:Nx) = us2;
Fs3(1,1:Nx) = us3;
Fs4(1,1:Nx) = us4;

for i = 1:t
    
    %-----Find u* = U(i,1) the 2 incoming roads-----
    a = 1-2*u13b;
    b = 1-2*F13(i,1);
    s = 1-u13b-F13(i,1);
    if a >= 0 && b >= 0
            U0 = u13b;
        elseif a <0 && b <0 
            U0 = F13(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U0 = u13b;
        elseif a >= 0 && b <0 && s < 0
            U0= F13(i,1);
        elseif a <0 && b >= 0
            U0 = .5;
    end
    a = 1-2*u7b;
    b = 1-2*F7(i,1);
    s = 1-u7b-F7(i,1);
    if a >= 0 && b >= 0
            U02 = u7b;
        elseif a <0 && b <0 
            U02 = F7(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U02 = u7b;
        elseif a >= 0 && b <0 && s < 0
            U02= F7(i,1);
        elseif a <0 && b >= 0
            U02 = .5;
    end
    
    
    
    
    %-- Find u* F1:
   for n = 1:Nx-1
        a = 1-2*F1(i,n);
        b = 1-2*F1(i,n+1);     
        s = 1- F1(i,n+1) - F1(i,n);
           
        if a >= 0 && b >= 0
            U1(i,n) = F1(i,n);
        elseif a <0 && b <0 
            U1(i,n) = F1(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U1(i,n) = F1(i,n);
        elseif a >= 0 && b <0 && s < 0
            U1(i,n)= F1(i,n+1);
        elseif a <0 && b >= 0
            U1(i,n) = .5;
        end
   end
   %-- Find u* F2:
   for n = 1:Nx-1
        a = 1-2*F2(i,n);
        b = 1-2*F2(i,n+1);     
        s = 1- F2(i,n+1) - F2(i,n);
           
        if a >= 0 && b >= 0
            U2(i,n) = F2(i,n);
        elseif a <0 && b <0 
            U2(i,n) = F2(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U2(i,n) = F2(i,n);
        elseif a >= 0 && b <0 && s < 0
            U2(i,n)= F2(i,n+1);
        elseif a <0 && b >= 0
            U2(i,n) = .5;
        end
   end
   %-- Find u* F3:
   for n = 1:Nx-1
        a = 1-2*F3(i,n);
        b = 1-2*F3(i,n+1);     
        s = 1- F3(i,n+1) - F3(i,n);
           
        if a >= 0 && b >= 0
            U3(i,n) = F3(i,n);
        elseif a <0 && b <0 
            U3(i,n) = F3(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U3(i,n) = F3(i,n);
        elseif a >= 0 && b <0 && s < 0
            U3(i,n)= F3(i,n+1);
        elseif a <0 && b >= 0
            U3(i,n) = .5;
        end
   end
   %-- Find u* F4:
   for n = 1:Nx-1
        a = 1-2*F4(i,n);
        b = 1-2*F4(i,n+1);     
        s = 1-F4(i,n+1) - F4(i,n);
           
        if a >= 0 && b >= 0
            U4(i,n) = F4(i,n);
        elseif a <0 && b <0 
            U4(i,n) = F4(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U4(i,n) = F4(i,n);
        elseif a >= 0 && b <0 && s < 0
            U4(i,n)= F4(i,n+1);
        elseif a <0 && b >= 0
            U4(i,n) = .5;
        end
   end  
   %-- Find u* F5:
   for n = 1:Nx-1
        a = 1-2*F5(i,n);
        b = 1-2*F5(i,n+1);     
        s = 1- F5(i,n+1) - F5(i,n);
           
        if a >= 0 && b >= 0
            U5(i,n) = F5(i,n);
        elseif a <0 && b <0 
            U5(i,n) = F5(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U5(i,n) = F5(i,n);
        elseif a >= 0 && b <0 && s < 0
            U5(i,n)= F5(i,n+1);
        elseif a <0 && b >= 0
            U5(i,n) = .5;
        end
   end
   %-- Find u* F6:
   for n = 1:Nx-1
        a = 1-2*F6(i,n);
        b = 1-2*F6(i,n+1);     
        s = 1- F6(i,n+1) - F6(i,n);
           
        if a >= 0 && b >= 0
            U6(i,n) = F6(i,n);
        elseif a <0 && b <0 
            U6(i,n) = F6(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U6(i,n) = F6(i,n);
        elseif a >= 0 && b <0 && s < 0
            U6(i,n)= F6(i,n+1);
        elseif a <0 && b >= 0
            U6(i,n) = .5;
        end
   end
   %-- Find u* F7:
   for n = 1:Nx-1
        a = 1-2*F7(i,n);
        b = 1-2*F7(i,n+1);     
        s = 1- F7(i,n+1) - F7(i,n);
           
        if a >= 0 && b >= 0
            U7(i,n) = F7(i,n);
        elseif a <0 && b <0 
            U7(i,n) = F7(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U7(i,n) = F7(i,n);
        elseif a >= 0 && b <0 && s < 0
            U7(i,n)= F7(i,n+1);
        elseif a <0 && b >= 0
            U7(i,n) = .5;
        end
   end
   %-- Find u* F8:
   for n = 1:Nx-1
        a = 1-2*F8(i,n);
        b = 1-2*F8(i,n+1);     
        s = 1- F8(i,n+1) - F8(i,n);
           
        if a >= 0 && b >= 0
            U8(i,n) = F8(i,n);
        elseif a <0 && b <0 
            U8(i,n) = F8(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U8(i,n) = F8(i,n);
        elseif a >= 0 && b <0 && s < 0
            U8(i,n)= F8(i,n+1);
        elseif a <0 && b >= 0
            U8(i,n) = .5;
        end
   end
   %-- Find u* F9:
   for n = 1:Nx-1
        a = 1-2*F9(i,n);
        b = 1-2*F9(i,n+1);     
        s = 1- F9(i,n+1) - F9(i,n);
           
        if a >= 0 && b >= 0
            U9(i,n) = F9(i,n);
        elseif a <0 && b <0 
            U9(i,n) = F9(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U9(i,n) = F9(i,n);
        elseif a >= 0 && b <0 && s < 0
            U9(i,n)= F9(i,n+1);
        elseif a <0 && b >= 0
            U9(i,n) = .5;
        end
   end
   %-- Find u* F10:
   for n = 1:Nx-1
        a = 1-2*F10(i,n);
        b = 1-2*F10(i,n+1);     
        s = 1- F10(i,n+1) - F10(i,n);
           
        if a >= 0 && b >= 0
            U10(i,n) = F10(i,n);
        elseif a <0 && b <0 
            U10(i,n) = F10(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U10(i,n) = F10(i,n);
        elseif a >= 0 && b <0 && s < 0
            U10(i,n)= F10(i,n+1);
        elseif a <0 && b >= 0
            U10(i,n) = .5;
        end
   end
   %-- Find u* F11:
   for n = 1:Nx-1
        a = 1-2*F11(i,n);
        b = 1-2*F11(i,n+1);     
        s = 1- F11(i,n+1) - F11(i,n);
           
        if a >= 0 && b >= 0
            U11(i,n) = F11(i,n);
        elseif a <0 && b <0 
            U11(i,n) = F11(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U11(i,n) = F11(i,n);
        elseif a >= 0 && b <0 && s < 0
            U11(i,n)= F11(i,n+1);
        elseif a <0 && b >= 0
            U11(i,n) = .5;
        end
   end
   %-- Find u* F12:
   for n = 1:Nx-1
        a = 1-2*F12(i,n);
        b = 1-2*F12(i,n+1);     
        s = 1- F12(i,n+1) - F12(i,n);
           
        if a >= 0 && b >= 0
            U12(i,n) = F12(i,n);
        elseif a <0 && b <0 
            U12(i,n) = F12(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U12(i,n) = F12(i,n);
        elseif a >= 0 && b <0 && s < 0
            U12(i,n)= F12(i,n+1);
        elseif a <0 && b >= 0
            U12(i,n) = .5;
        end
   end
   %-- Find u* F13:
   for n = 1:Nx-1
        a = 1-2*F13(i,n);
        b = 1-2*F13(i,n+1);     
        s = 1- F13(i,n+1) - F13(i,n);
           
        if a >= 0 && b >= 0
            U13(i,n) = F13(i,n);
        elseif a <0 && b <0 
            U13(i,n) = F13(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U13(i,n) = F13(i,n);
        elseif a >= 0 && b <0 && s < 0
            U13(i,n)= F13(i,n+1);
        elseif a <0 && b >= 0
            U13(i,n) = .5;
        end
   end
   
   %-- Find u* Fs1:
   for n = 1:Nx-1
        a = 1-4*Fs1(i,n);
        b = 1-4*Fs1(i,n+1);     
        s = 1- 2*Fs1(i,n+1) - 2*Fs1(i,n);
           
        if a >= 0 && b >= 0
            Us1(i,n) = Fs1(i,n);
        elseif a <0 && b <0 
            Us1(i,n) = Fs1(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us1(i,n) = Fs1(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us1(i,n)= Fs1(i,n+1);
        elseif a <0 && b >= 0
            Us1(i,n) = 1/4;
        end
   end
   %-- Find u* Fs2:
   for n = 1:Nx-1
        a = 1-4*Fs2(i,n);
        b = 1-4*Fs2(i,n+1);     
        s = 1- 2*Fs2(i,n+1) - 2*Fs2(i,n);
           
        if a >= 0 && b >= 0
            Us2(i,n) = Fs2(i,n);
        elseif a <0 && b <0 
            Us2(i,n) = Fs2(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us2(i,n) = Fs2(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us2(i,n)= Fs2(i,n+1);
        elseif a <0 && b >= 0
            Us2(i,n) = 1/4;
        end
   end
   %-- Find u* Fs3:
   for n = 1:Nx-1
        a = 1-4*Fs3(i,n);
        b = 1-4*Fs3(i,n+1);     
        s = 1- 2*Fs3(i,n+1) - 2*Fs3(i,n);
           
        if a >= 0 && b >= 0
            Us3(i,n) = Fs3(i,n);
        elseif a <0 && b <0 
            Us3(i,n) = Fs3(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us3(i,n) = Fs3(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us3(i,n)= Fs3(i,n+1);
        elseif a <0 && b >= 0
            Us3(i,n) = 1/4;
        end
   end
   %-- Find u* Fs4:
   for n = 1:Nx-1
        a = 1-4*Fs4(i,n);
        b = 1-4*Fs4(i,n+1);     
        s = 1- 2*Fs4(i,n+1) - 2*Fs4(i,n);
           
        if a >= 0 && b >= 0
            Us4(i,n) = Fs4(i,n);
        elseif a <0 && b <0 
            Us4(i,n) = Fs4(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us4(i,n) = Fs4(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us4(i,n)= Fs4(i,n+1);
        elseif a <0 && b >= 0
            Us4(i,n) = 1/4;
        end
   end
   
   
   
   %Find the flux for the next timestep for 2:Nx-1
   for n = 2:Nx-1
       F1(i+1,n)  = F1(i,n)  -(k/h)*((U1(i,n)-U1(i,n)^2)-(U1(i,n-1)-U1(i,n-1)^2));
       F2(i+1,n)  = F2(i,n)  -(k/h)*((U2(i,n)-U2(i,n)^2)-(U2(i,n-1)-U2(i,n-1)^2));
       F3(i+1,n)  = F3(i,n)  -(k/h)*((U3(i,n)-U3(i,n)^2)-(U3(i,n-1)-U3(i,n-1)^2));
       F4(i+1,n)  = F4(i,n)  -(k/h)*((U4(i,n)-U4(i,n)^2)-(U4(i,n-1)-U4(i,n-1)^2));
       F5(i+1,n)  = F5(i,n)  -(k/h)*((U5(i,n)-U5(i,n)^2)-(U5(i,n-1)-U5(i,n-1)^2));
       F6(i+1,n)  = F6(i,n)  -(k/h)*((U6(i,n)-U6(i,n)^2)-(U6(i,n-1)-U6(i,n-1)^2));
       F7(i+1,n)  = F7(i,n)  -(k/h)*((U7(i,n)-U7(i,n)^2)-(U7(i,n-1)-U7(i,n-1)^2));
       F8(i+1,n)  = F8(i,n)  -(k/h)*((U8(i,n)-U8(i,n)^2)-(U8(i,n-1)-U8(i,n-1)^2));
       F9(i+1,n)  = F9(i,n)  -(k/h)*((U9(i,n)-U9(i,n)^2)-(U9(i,n-1)-U9(i,n-1)^2));    
       F10(i+1,n) = F10(i,n) -(k/h)*((U10(i,n)-U10(i,n)^2)-(U10(i,n-1)-U10(i,n-1)^2));    
       F11(i+1,n) = F11(i,n) -(k/h)*((U11(i,n)-U11(i,n)^2)-(U11(i,n-1)-U11(i,n-1)^2));    
       F12(i+1,n) = F12(i,n) -(k/h)*((U12(i,n)-U12(i,n)^2)-(U12(i,n-1)-U12(i,n-1)^2));    
       F13(i+1,n) = F13(i,n) -(k/h)*((U13(i,n)-U13(i,n)^2)-(U13(i,n-1)-U13(i,n-1)^2));    
       Fs1(i+1,n) = Fs1(i,n) -(k/h)*((Us1(i,n)-2*Us1(i,n)^2)-(Us1(i,n-1)-2*Us1(i,n-1)^2));    
       Fs2(i+1,n) = Fs2(i,n) -(k/h)*((Us2(i,n)-2*Us2(i,n)^2)-(Us2(i,n-1)-2*Us2(i,n-1)^2));    
       Fs3(i+1,n) = Fs3(i,n) -(k/h)*((Us3(i,n)-2*Us3(i,n)^2)-(Us3(i,n-1)-2*Us3(i,n-1)^2));    
       Fs4(i+1,n) = Fs4(i,n) -(k/h)*((Us4(i,n)-2*Us4(i,n)^2)-(Us4(i,n-1)-2*Us4(i,n-1)^2));      
   end
   %-- Maxfluxene Out (4.2.3) 
   bout(1:17) = [F1(i,Nx) F2(i,Nx) F3(i,Nx) F4(i,Nx) F5(i,Nx) F6(i,Nx) F7(i,Nx) F8(i,Nx) F9(i,Nx) F10(i,Nx) F11(i,Nx) F12(i,Nx) F13(i,Nx) Fs1(i,Nx) Fs2(i,Nx) Fs3(i,Nx) Fs4(i,Nx)];
   for l = 1:13
      if bout(l) <= .5
        b(l) = bout(l) -bout(l)^2;
   else
       b(l) = 1/4;
      end
   end
   
   %sideroads
   for l = 14:17
      if bout(l) <= 1/4
        b(l) = bout(l) -2*bout(l)^2;
   else
       b(l) = 1/8;
      end
   end
   
   %Maxfluxes in (4.2.2)
   bin(1:17) = [F1(i,1) F2(i,1) F3(i,1) F4(i,1) F5(i,1) F6(i,1) F7(i,1) F8(i,1) F9(i,1) F10(i,1) F11(i,1) F12(i,1) F13(i,1) Fs1(i,1) Fs2(i,1) Fs3(i,1) Fs4(i,1)];
   for L = 1:13
   if bin(L) <= .5
       a(L) = 1/4;
   else
       a(L) = bin(L)-bin(L)^2;
   end
   end
   % side roads
   for L = 14:17
   if bin(L) <= 1/4
       a(L) = 1/8;
   else
       a(L) = bin(L)-2*bin(L)^2;
   end
   end
   
    % Flux for the boundaries..
   %Junctions with 2 incoming, 1 outgoing (5)
   
   %Junction(4,s3 ->3) 2 
   In3 = min(b(4)+ b(16),a(3));
   Out4 = b(4);
   Outs3 = b(16);
   if b(4)+ b(16) > a(3)
   Out4 = q*In3;
   Outs3 =(1-q)*In3;
   if Out4 > b(4)
   Out4 = b(4);
   Outs3 = In3 - b(4);
   elseif Outs3 > b(16) 
   Outs3 = b(16);
   Out4 = In3 -b(16);
   end
   end
   %Junction(6,s1 -> 5)
   In5 = min(b(6)+ b(14),a(5));
   Out6 = b(6);
   Outs1 = b(14);
   if b(6)+ b(14) > a(5)
   Out6 = q*In5;
   Outs1 =(1-q)*In5;
   if Out6 > b(6)
   Out6 = b(6);
   Outs1 = In5 - b(6);
   elseif Outs1 > b(14) 
   Outs1 = b(14);
   Out6 = In5 -b(14);
   end
   end
   %Junction(7,s2 -> 8)
   In8 = min(b(7)+ b(15),a(8));
   Out7 = b(7);
   Outs2 = b(15);
   if b(7)+ b(15) > a(8)
   Out7 = q*In8;
   Outs2 =(1-q)*In8;
   if Out7 > b(7)
   Out7 = b(7);
   Outs2 = In8 - b(7);
   elseif Outs2 > b(15) 
   Outs2 = b(15);
   Out7 = In8 -b(15);
   end
   end
   %Junction(12,s4 -> 11)
   In11 = min(b(12)+ b(17),a(11));
   Out12 = b(12);
   Outs4 = b(17);
   if b(12) + b(17) > a(11)
   Out12 = q*In11;
   Outs4 =(1-q)*In11;
   if Out12 > b(12)
   Out12 = b(12);
   Outs4 = In11 - b(12);
   elseif Outs4 > b(17) 
   Outs4 = b(17);
   Out12 = In11 -b(17);
   end
   end
   %------------------------
   %Junction(11,9 -> 10)
   %(NB the case with 3 big roads q = .5)
   q1 = .5;
   In10 = min(b(11)+ b(9),a(10));
   Out11 = b(11);
   Out9 = b(9);
   if b(11)+ b(9) < a(10)
   Out11 = q1*In10;
   Out9 =(1-q1)*In10;
   if Out11 > b(11)
   Out11 = b(11);
   Out9 = In10 - b(11);
   elseif Out9 > b(9) 
   Out9 = b(9);
   Out11 = In10 -b(9);
   end
   end
   %--------------------
    
   
   % Junctions with 1 incoming and 2 outgoing(5)
   
   %Junction(5 -> 2,4) 
   In2  = min(alpha*b(5),a(2));
   In4 = min(alpha*b(5),a(4));
   Out5 = In2 + In4;
   %Junction(2 -> s1,1)
   In1  = min(alpha1*b(2),a(1));
   Ins1 = min(alpha2*b(2),a(14));
   Out2 = In1 + Ins1;
   %Junction(10 -> s2,6) 
   In6  = min(alpha1*b(10),a(6));
   Ins2 = min(alpha2*b(10),a(15));
   Out10 = In6 + Ins2;
   %Junction(8 -> s4,9)
   In9  = min(alpha1*b(8),a(9));
   Ins4 = min(alpha2*b(8),a(17));
   Out8 = In9 + Ins4;
   %Junction(13 -> s3,12)
   In12 = min(alpha1*b(13),a(12));
   Ins3 = min(alpha2*b(13),a(16));
   Out13= In12 + Ins3;
   
     %---------Boundaries-------------
   
       %Incoming roads [13 and 7]
       F13(i+1,1) = F13(i,1) -(k/h)*((U13(i,1)-U13(i,1)^2)-(U0-(U0)^2));
       F7(i+1,1) = F7(i,1) -(k/h)*((U7(i,1)-U7(i,1)^2)-(U02-(U02)^2));
       %roads with outgoing fluxes [All except 1 and 3]
       F2(i+1,Nx)   = F2(i,Nx) -(k/h)*(Out2-(U2(i,Nx-1)-U2(i,Nx-1)^2));
       F13(i+1,Nx)   = F13(i,Nx) -(k/h)*(Out13-(U13(i,Nx-1)-U13(i,Nx-1)^2));
       F4(i+1,Nx)   = F4(i,Nx) -(k/h)*(Out4-(U4(i,Nx-1)-U4(i,Nx-1)^2));
       F5(i+1,Nx)   = F5(i,Nx) -(k/h)*(Out5-(U5(i,Nx-1)-U5(i,Nx-1)^2));
       F6(i+1,Nx)   = F6(i,Nx) -(k/h)*(Out6-(U6(i,Nx-1)-U6(i,Nx-1)^2));
       F7(i+1,Nx)   = F7(i,Nx) -(k/h)*(Out7-(U7(i,Nx-1)-U7(i,Nx-1)^2));
       F8(i+1,Nx)   = F8(i,Nx) -(k/h)*(Out8-(U8(i,Nx-1)-U8(i,Nx-1)^2));
       F9(i+1,Nx)   = F9(i,Nx) -(k/h)*(Out9-(U9(i,Nx-1)-U9(i,Nx-1)^2));
       F10(i+1,Nx)   = F10(i,Nx) -(k/h)*(Out10-(U10(i,Nx-1)-U10(i,Nx-1)^2));
       F11(i+1,Nx)   = F11(i,Nx) -(k/h)*(Out11-(U11(i,Nx-1)-U11(i,Nx-1)^2));
       F12(i+1,Nx)   = F12(i,Nx) -(k/h)*(Out12-(U12(i,Nx-1)-U12(i,Nx-1)^2));
       Fs1(i+1,Nx)   = Fs1(i,Nx) -(k/h)*(Outs1-(Us1(i,Nx-1)-2*Us1(i,Nx-1)^2));
       Fs2(i+1,Nx)   = Fs2(i,Nx) -(k/h)*(Outs2-(Us2(i,Nx-1)-2*Us2(i,Nx-1)^2));
       Fs3(i+1,Nx)   = Fs3(i,Nx) -(k/h)*(Outs3-(Us3(i,Nx-1)-2*Us3(i,Nx-1)^2));
       Fs4(i+1,Nx)   = Fs4(i,Nx) -(k/h)*(Outs4-(Us4(i,Nx-1)-2*Us4(i,Nx-1)^2));
       
       %Roads with incoming fluxes [All except 7 and 13]
       F1(i+1,1)    = F1(i,1) -(k/h)*((U1(i,1)-U1(i,1)^2)-In1);
       F2(i+1,1)    = F2(i,1) -(k/h)*((U2(i,1)-U2(i,1)^2)-In2);
       F4(i+1,1)    = F4(i,1) -(k/h)*((U4(i,1)-U4(i,1)^2)-In4);
       F5(i+1,1)    = F5(i,1) -(k/h)*((U5(i,1)-U5(i,1)^2)-In5);
       F6(i+1,1)    = F6(i,1) -(k/h)*((U6(i,1)-U6(i,1)^2)-In6);
       F8(i+1,1)    = F8(i,1) -(k/h)*((U8(i,1)-U8(i,1)^2)-In8);
       F9(i+1,1)    = F9(i,1) -(k/h)*((U9(i,1)-U9(i,1)^2)-In9);
       F10(i+1,1)   = F10(i,1) -(k/h)*((U10(i,1)-U10(i,1)^2)-In10);
       F11(i+1,1)   = F11(i,1) -(k/h)*((U11(i,1)-U11(i,1)^2)-In11);
       F12(i+1,1)   = F12(i,1) -(k/h)*((U12(i,1)-U12(i,1)^2)-In12);
       F3(i+1,1)    = F3(i,1) -(k/h)*((U3(i,1)-U3(i,1)^2)-In3);
       Fs1(i+1,1)   = Fs1(i,1) -(k/h)*((Us1(i,1)-2*Us1(i,1)^2)-Ins1);
       Fs2(i+1,1)   = Fs2(i,1) -(k/h)*((Us2(i,1)-2*Us2(i,1)^2)-Ins2);
       Fs3(i+1,1)   = Fs3(i,1) -(k/h)*((Us3(i,1)-2*Us3(i,1)^2)-Ins3);
       Fs4(i+1,1)   = Fs4(i,1) -(k/h)*((Us4(i,1)-2*Us4(i,1)^2)-Ins4);
       %Outgoing roads [1 and 13]
       F1(i+1,Nx)  = F1(i+1,Nx-1);
       F3(i+1,Nx)  = F3(i+1,Nx-1);
       
end
MAX1 = max(max([F1 F2 F3 F4 F5 F6 F7 F8 F9 F10 F11 F12 F13]));
MIN1 = min(min([F1 F2 F3 F4 F5 F6 F7 F8 F9 F10 F11 F12 F13]));
MAX2 = max(max([Fs1 Fs2 Fs3 Fs4]));
MIN2 = min(min([Fs1 Fs2 Fs3 Fs4]));