%---From the figure Model C of Trondheim.
%---Everything above line 38 are initial values and can be changed. 
clear;
h = 0.025;          % Step i x-direction
T = 35;             % Time steps
q =.70;             % Right of way parameter for roads junctions with 2 incomming and 1 outgoing roads.
alpha1 =.70;        % Procentage of cars from big roads to big roads in junctions with 1 incomming and 2 outgoing. 
alpha2 =.30;        % Procentage of cars from big roads to small roads in junctions with 1 incomming and 2 outging.
%-------- Initial values of the 22 roads
u1  = .35;
u2  = .35;
u3  = .2;
u4  = .4;
u5  = .35;
u6  = .4;
u7  = .7;
u8  = .7;
u9  = .6;
u10 = .5;
u11 = .25;
u12 = .5;
u13 = .25;
u14 = .5;
u15 = .4;
u16 = .7;
u17 = .45;
u18 = .35;
%--"sideroads"--
us1 = .1;
us2 = .3;
us3 = .4;
us4 =  0;
%---- Flux on the 4 incomming roads.
u1b  =   0;
u5b  = .45;
u13b = .15;
u18b = .25;
%--------------------------------------------------------------------------
A = [.1 .5 .4;...   % Distribution matrix for the junctions with 3 incomming and 3 outgoing roads.  
     .5 .4 .1;...
     .4 .1 .5];
k = h;
x = 0:h:1;       % Points of the roads
Nx = length(x);  % number of steps in x-direction
t = floor(T/k);  % number of steps in t-direction
%Starting flux on the roads (F1 is road 1 etc.) 
F1(1,1:Nx) = u1;
F2(1,1:Nx) = u2;
F3(1,1:Nx) = u3;
F4(1,1:Nx) = u4;
F5(1,1:Nx) = u5;
F6(1,1:Nx) = u6;
F7(1,1:Nx) = u7;
F8(1,1:Nx) = u8;
F9(1,1:Nx) = u9;
F10(1,1:Nx) = u10;
F11(1,1:Nx) = u11;
F12(1,1:Nx) = u12;
F13(1,1:Nx) = u13;
F14(1,1:Nx) = u14;
F15(1,1:Nx) = u15;
F16(1,1:Nx) = u16;
F17(1,1:Nx) = u17;
F18(1,1:Nx) = u18;
Fs1(1,1:Nx) = us1;
Fs2(1,1:Nx) = us2;
Fs3(1,1:Nx) = us3;
Fs4(1,1:Nx) = us4;

for i = 1:t
    v = [0;0;0];    
    v2 = [0;0;0];
    %-----find u* = U(i,1) for the 4 incoming roads-----
    a = 1-2*u1b;
    b = 1-2*F1(i,1);
    s = 1-u1b-F1(i,1);
    if a >= 0 && b >= 0
            U01 = u1b;
        elseif a <0 && b <0 
            U1 = F1(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U01 = u1b;
        elseif a >= 0 && b <0 && s < 0
            U01= F1(i,1);
        elseif a <0 && b >= 0
            U01 = .5;
    end
    a = 1-2*u5b;
    b = 1-2*F5(i,1);
    s = 1-u5b-F5(i,1);
    if a >= 0 && b >= 0
            U05 = u5b;
        elseif a <0 && b <0 
            U05 = F5(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U05 = u5b;
        elseif a >= 0 && b <0 && s < 0
            U05= F5(i,1);
        elseif a <0 && b >= 0
            U05 = .5;
    end
    
    a = 1-2*u13b;
    b = 1-2*F13(i,1);
    s = 1-u13b-F13(i,1);
    if a >= 0 && b >= 0
            U013 = u13b;
        elseif a <0 && b <0 
            U013 = F13(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U013 = u13b;
        elseif a >= 0 && b <0 && s < 0
            U013= F13(i,1);
        elseif a <0 && b >= 0
            U013 = .5;
    end
    a = 1-2*u18b;
    b = 1-2*F18(i,1);
    s = 1-u18b-F18(i,1);
    if a >= 0 && b >= 0
            U018 = u18b;
        elseif a <0 && b <0 
            U018 = F18(i,1);
        elseif a >= 0 && b < 0 && s >= 0
            U018 = u18b;
        elseif a >= 0 && b <0 && s < 0
            U018= F18(i,1);
        elseif a <0 && b >= 0
            U018 = .5;
    end
        
    %-- Find u* F1:
   for n = 1:Nx-1
        a = 1-2*F1(i,n);            % f'(u(i,n))
        b = 1-2*F1(i,n+1);          % f'(u(i,n+1))
        s = 1- F1(i,n+1) - F1(i,n); % Rankine-Hugoniot condition
           
        if a >= 0 && b >= 0
            U1(i,n) = F1(i,n);
        elseif a <0 && b <0 
            U1(i,n) = F1(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U1(i,n) = F1(i,n);
        elseif a >= 0 && b <0 && s < 0
            U1(i,n)= F1(i,n+1);
        elseif a <0 && b >= 0
            U1(i,n) = .5;
        end
   end
   %-- Find u* F2:
   for n = 1:Nx-1
        a = 1-2*F2(i,n);
        b = 1-2*F2(i,n+1);     
        s = 1- F2(i,n+1) - F2(i,n);
           
        if a >= 0 && b >= 0
            U2(i,n) = F2(i,n);
        elseif a <0 && b <0 
            U2(i,n) = F2(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U2(i,n) = F2(i,n);
        elseif a >= 0 && b <0 && s < 0
            U2(i,n)= F2(i,n+1);
        elseif a <0 && b >= 0
            U2(i,n) = .5;
        end
   end
   %-- Find u* F3:
   for n = 1:Nx-1
        a = 1-2*F3(i,n);
        b = 1-2*F3(i,n+1);     
        s = 1- F3(i,n+1) - F3(i,n);
           
        if a >= 0 && b >= 0
            U3(i,n) = F3(i,n);
        elseif a <0 && b <0 
            U3(i,n) = F3(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U3(i,n) = F3(i,n);
        elseif a >= 0 && b <0 && s < 0
            U3(i,n)= F3(i,n+1);
        elseif a <0 && b >= 0
            U3(i,n) = .5;
        end
   end
   %-- Find u* F4:
   for n = 1:Nx-1
        a = 1-2*F4(i,n);
        b = 1-2*F4(i,n+1);     
        s = 1-F4(i,n+1) - F4(i,n);
           
        if a >= 0 && b >= 0
            U4(i,n) = F4(i,n);
        elseif a <0 && b <0 
            U4(i,n) = F4(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U4(i,n) = F4(i,n);
        elseif a >= 0 && b <0 && s < 0
            U4(i,n)= F4(i,n+1);
        elseif a <0 && b >= 0
            U4(i,n) = .5;
        end
   end
   %-- Find u* F5:
   for n = 1:Nx-1
        a = 1-2*F5(i,n);
        b = 1-2*F5(i,n+1);     
        s = 1- F5(i,n+1) - F5(i,n);
           
        if a >= 0 && b >= 0
            U5(i,n) = F5(i,n);
        elseif a <0 && b <0 
            U5(i,n) = F5(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U5(i,n) = F5(i,n);
        elseif a >= 0 && b <0 && s < 0
            U5(i,n)= F5(i,n+1);
        elseif a <0 && b >= 0
            U5(i,n) = .5;
        end
   end
   %-- Find u* F6:
   for n = 1:Nx-1
        a = 1-2*F6(i,n);
        b = 1-2*F6(i,n+1);     
        s = 1- F6(i,n+1) - F6(i,n);
           
        if a >= 0 && b >= 0
            U6(i,n) = F6(i,n);
        elseif a <0 && b <0 
            U6(i,n) = F6(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U6(i,n) = F6(i,n);
        elseif a >= 0 && b <0 && s < 0
            U6(i,n)= F6(i,n+1);
        elseif a <0 && b >= 0
            U6(i,n) = .5;
        end
   end
   %-- Find u* F7:
   for n = 1:Nx-1
        a = 1-2*F7(i,n);
        b = 1-2*F7(i,n+1);     
        s = 1- F7(i,n+1) - F7(i,n);
           
        if a >= 0 && b >= 0
            U7(i,n) = F7(i,n);
        elseif a <0 && b <0 
            U7(i,n) = F7(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U7(i,n) = F7(i,n);
        elseif a >= 0 && b <0 && s < 0
            U7(i,n)= F7(i,n+1);
        elseif a <0 && b >= 0
            U7(i,n) = .5;
        end
   end
   %-- Find u* F8:
   for n = 1:Nx-1
        a = 1-2*F8(i,n);
        b = 1-2*F8(i,n+1);     
        s = 1- F8(i,n+1) - F8(i,n);
           
        if a >= 0 && b >= 0
            U8(i,n) = F8(i,n);
        elseif a <0 && b <0 
            U8(i,n) = F8(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U8(i,n) = F8(i,n);
        elseif a >= 0 && b <0 && s < 0
            U8(i,n)= F8(i,n+1);
        elseif a <0 && b >= 0
            U8(i,n) = .5;
        end
   end
   %-- Find u* F9:
   for n = 1:Nx-1
        a = 1-2*F9(i,n);    
        b = 1-2*F9(i,n+1);     
        s = 1- F9(i,n+1) - F9(i,n);
           
        if a >= 0 && b >= 0
            U9(i,n) = F9(i,n);
        elseif a <0 && b <0 
            U9(i,n) = F9(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U9(i,n) = F9(i,n);
        elseif a >= 0 && b <0 && s < 0
            U9(i,n)= F9(i,n+1);
        elseif a <0 && b >= 0
            U9(i,n) = .5;
        end
   end
   %-- Find u* F10:
   for n = 1:Nx-1
        a = 1-2*F10(i,n);
        b = 1-2*F10(i,n+1);     
        s = 1- F10(i,n+1) - F10(i,n);
           
        if a >= 0 && b >= 0
            U10(i,n) = F10(i,n);
        elseif a <0 && b <0 
            U10(i,n) = F10(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U10(i,n) = F10(i,n);
        elseif a >= 0 && b <0 && s < 0
            U10(i,n)= F10(i,n+1);
        elseif a <0 && b >= 0
            U10(i,n) = .5;
        end
   end
   %-- Find u* F11:
   for n = 1:Nx-1
        a = 1-2*F11(i,n);
        b = 1-2*F11(i,n+1);     
        s = 1- F11(i,n+1) - F11(i,n);
           
        if a >= 0 && b >= 0
            U11(i,n) = F11(i,n);
        elseif a <0 && b <0 
            U11(i,n) = F11(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U11(i,n) = F11(i,n);
        elseif a >= 0 && b <0 && s < 0
            U11(i,n)= F11(i,n+1);
        elseif a <0 && b >= 0
            U11(i,n) = .5;
        end
   end
   %-- Find u* F12:
   for n = 1:Nx-1
        a = 1-2*F12(i,n);
        b = 1-2*F12(i,n+1);     
        s = 1- F12(i,n+1) - F12(i,n);
           
        if a >= 0 && b >= 0
            U12(i,n) = F12(i,n);
        elseif a <0 && b <0 
            U12(i,n) = F12(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U12(i,n) = F12(i,n);
        elseif a >= 0 && b <0 && s < 0
            U12(i,n)= F12(i,n+1);
        elseif a <0 && b >= 0
            U12(i,n) = .5;
        end
   end
   %-- Find u* F13:
   for n = 1:Nx-1
        a = 1-2*F13(i,n);
        b = 1-2*F13(i,n+1);     
        s = 1- F13(i,n+1) - F13(i,n);
           
        if a >= 0 && b >= 0
            U13(i,n) = F13(i,n);
        elseif a <0 && b <0 
            U13(i,n) = F13(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U13(i,n) = F13(i,n);
        elseif a >= 0 && b <0 && s < 0
            U13(i,n)= F13(i,n+1);
        elseif a <0 && b >= 0
            U13(i,n) = .5;
        end
   end
   %-- Find u* F14:
   for n = 1:Nx-1
        a = 1-2*F14(i,n);
        b = 1-2*F14(i,n+1);     
        s = 1- F14(i,n+1) - F14(i,n);
           
        if a >= 0 && b >= 0
            U14(i,n) = F14(i,n);
        elseif a <0 && b <0 
            U14(i,n) = F14(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U14(i,n) = F14(i,n);
        elseif a >= 0 && b <0 && s < 0
            U14(i,n)= F14(i,n+1);
        elseif a <0 && b >= 0
            U14(i,n) = .5;
        end
   end
   %-- Find u* F15:
   for n = 1:Nx-1
        a = 1-2*F15(i,n);
        b = 1-2*F15(i,n+1);     
        s = 1- F15(i,n+1) - F15(i,n);
           
        if a >= 0 && b >= 0
            U15(i,n) = F15(i,n);
        elseif a <0 && b <0 
            U15(i,n) = F15(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U15(i,n) = F15(i,n);
        elseif a >= 0 && b <0 && s < 0
            U15(i,n)= F15(i,n+1);
        elseif a <0 && b >= 0
            U15(i,n) = .5;
        end
   end
   %-- Find u* F16:
   for n = 1:Nx-1
        a = 1-2*F16(i,n);
        b = 1-2*F16(i,n+1);     
        s = 1- F16(i,n+1) - F16(i,n);
           
        if a >= 0 && b >= 0
            U16(i,n) = F16(i,n);
        elseif a <0 && b <0 
            U16(i,n) = F16(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U16(i,n) = F16(i,n);
        elseif a >= 0 && b <0 && s < 0
            U16(i,n)= F16(i,n+1);
        elseif a <0 && b >= 0
            U16(i,n) = .5;
        end
   end
   %-- Find u* F17:
   for n = 1:Nx-1
        a = 1-2*F17(i,n);
        b = 1-2*F17(i,n+1);     
        s = 1- F17(i,n+1) - F17(i,n);
           
        if a >= 0 && b >= 0
            U17(i,n) = F17(i,n);
        elseif a <0 && b <0 
            U17(i,n) = F17(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U17(i,n) = F17(i,n);
        elseif a >= 0 && b <0 && s < 0
            U17(i,n)= F17(i,n+1);
        elseif a <0 && b >= 0
            U17(i,n) = .5;
        end
   end
   %-- Find u* F18:
   for n = 1:Nx-1
        a = 1-2*F18(i,n);
        b = 1-2*F18(i,n+1);     
        s = 1- F18(i,n+1) - F18(i,n);
           
        if a >= 0 && b >= 0
            U18(i,n) = F18(i,n);
        elseif a <0 && b <0 
            U18(i,n) = F18(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            U18(i,n) = F18(i,n);
        elseif a >= 0 && b <0 && s < 0
            U18(i,n)= F18(i,n+1);
        elseif a <0 && b >= 0
            U18(i,n) = .5;
        end
   end
   %-- Find u* Fs1:
   for n = 1:Nx-1
        a = 1-4*Fs1(i,n);
        b = 1-4*Fs1(i,n+1);     
        s = 1- 2*Fs1(i,n+1) - 2*Fs1(i,n);
           
        if a >= 0 && b >= 0
            Us1(i,n) = Fs1(i,n);
        elseif a <0 && b <0 
            Us1(i,n) = Fs1(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us1(i,n) = Fs1(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us1(i,n)= Fs1(i,n+1);
        elseif a <0 && b >= 0
            Us1(i,n) = 1/4;
        end
   end
   %-- Find u* Fs2:
   for n = 1:Nx-1
        a = 1-4*Fs2(i,n);
        b = 1-4*Fs2(i,n+1);     
        s = 1- 2*Fs2(i,n+1) - 2*Fs2(i,n);
           
        if a >= 0 && b >= 0
            Us2(i,n) = Fs2(i,n);
        elseif a <0 && b <0 
            Us2(i,n) = Fs2(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us2(i,n) = Fs2(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us2(i,n)= Fs2(i,n+1);
        elseif a <0 && b >= 0
            Us2(i,n) = 1/4;
        end
   end
      %-- Find u* Fs3:
   for n = 1:Nx-1
        a = 1-4*Fs3(i,n);
        b = 1-4*Fs3(i,n+1);     
        s = 1- 2*Fs3(i,n+1) - 2*Fs3(i,n);
           
        if a >= 0 && b >= 0
            Us3(i,n) = Fs3(i,n);
        elseif a <0 && b <0 
            Us3(i,n) = Fs3(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us3(i,n) = Fs3(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us3(i,n)= Fs3(i,n+1);
        elseif a <0 && b >= 0
            Us3(i,n) = 1/4;
        end
   end
      %-- Find u* Fs4:
   for n = 1:Nx-1
        a = 1-4*Fs4(i,n);
        b = 1-4*Fs4(i,n+1);     
        s = 1- 2*Fs4(i,n+1) - 2*Fs4(i,n);
           
        if a >= 0 && b >= 0
            Us4(i,n) = Fs4(i,n);
        elseif a <0 && b <0 
            Us4(i,n) = Fs4(i,n+1);
        elseif a >= 0 && b < 0 && s >= 0
            Us4(i,n) = Fs4(i,n);
        elseif a >= 0 && b <0 && s < 0
            Us4(i,n)= Fs4(i,n+1);
        elseif a <0 && b >= 0
            Us4(i,n) = 1/4;
        end
   end
      %Find the flux for the next timestep for 2:Nx-1
for n = 2:Nx-1
  F1(i+1,n) = F1(i,n) -(k/h)*((U1(i,n)-U1(i,n)^2)-(U1(i,n-1)-U1(i,n-1)^2));
  F2(i+1,n) = F2(i,n) -(k/h)*((U2(i,n)-U2(i,n)^2)-(U2(i,n-1)-U2(i,n-1)^2));
  F3(i+1,n) = F3(i,n) -(k/h)*((U3(i,n)-U3(i,n)^2)-(U3(i,n-1)-U3(i,n-1)^2));
  F4(i+1,n) = F4(i,n) -(k/h)*((U4(i,n)-U4(i,n)^2)-(U4(i,n-1)-U4(i,n-1)^2));
  F5(i+1,n) = F5(i,n) -(k/h)*((U5(i,n)-U5(i,n)^2)-(U5(i,n-1)-U5(i,n-1)^2));
  F6(i+1,n) = F6(i,n) -(k/h)*((U6(i,n)-U6(i,n)^2)-(U6(i,n-1)-U6(i,n-1)^2));
  F7(i+1,n) = F7(i,n) -(k/h)*((U7(i,n)-U7(i,n)^2)-(U7(i,n-1)-U7(i,n-1)^2));
  F8(i+1,n) = F8(i,n) -(k/h)*((U8(i,n)-U8(i,n)^2)-(U8(i,n-1)-U8(i,n-1)^2));
  F9(i+1,n) = F9(i,n) -(k/h)*((U9(i,n)-U9(i,n)^2)-(U9(i,n-1)-U9(i,n-1)^2));    
  F10(i+1,n)= F10(i,n)-(k/h)*((U10(i,n)-U10(i,n)^2)-(U10(i,n-1)-U10(i,n-1)^2));    
  F11(i+1,n)= F11(i,n)-(k/h)*((U11(i,n)-U11(i,n)^2)-(U11(i,n-1)-U11(i,n-1)^2));    
  F12(i+1,n)= F12(i,n)-(k/h)*((U12(i,n)-U12(i,n)^2)-(U12(i,n-1)-U12(i,n-1)^2));    
  F13(i+1,n)= F13(i,n)-(k/h)*((U13(i,n)-U13(i,n)^2)-(U13(i,n-1)-U13(i,n-1)^2));
  F14(i+1,n)= F14(i,n)-(k/h)*((U14(i,n)-U14(i,n)^2)-(U14(i,n-1)-U14(i,n-1)^2));
  F15(i+1,n)= F15(i,n)-(k/h)*((U15(i,n)-U15(i,n)^2)-(U15(i,n-1)-U15(i,n-1)^2));
  F16(i+1,n)= F16(i,n)-(k/h)*((U16(i,n)-U16(i,n)^2)-(U16(i,n-1)-U16(i,n-1)^2));
  F17(i+1,n)= F17(i,n)-(k/h)*((U17(i,n)-U17(i,n)^2)-(U17(i,n-1)-U17(i,n-1)^2));
  F18(i+1,n)= F18(i,n)-(k/h)*((U18(i,n)-U18(i,n)^2)-(U18(i,n-1)-U18(i,n-1)^2));
  Fs1(i+1,n)= Fs1(i,n)-(k/h)*((Us1(i,n)-2*Us1(i,n)^2)...
                      -(Us1(i,n-1)-2*Us1(i,n-1)^2));    
  Fs2(i+1,n)= Fs2(i,n)-(k/h)*((Us2(i,n)-2*Us2(i,n)^2)...
                      -(Us2(i,n-1)-2*Us2(i,n-1)^2));    
  Fs3(i+1,n)= Fs3(i,n)-(k/h)*((Us3(i,n)-2*Us3(i,n)^2)...
                      -(Us3(i,n-1)-2*Us3(i,n-1)^2));    
  Fs4(i+1,n)= Fs4(i,n)-(k/h)*((Us4(i,n)-2*Us4(i,n)^2)...
                      -(Us4(i,n-1)-2*Us4(i,n-1)^2));      
end
  bout(1:22) = [F1(i,Nx) F2(i,Nx) F3(i,Nx) F4(i,Nx) F5(i,Nx) F6(i,Nx) F7(i,Nx) F8(i,Nx) F9(i,Nx) F10(i,Nx) F11(i,Nx) F12(i,Nx) F13(i,Nx) F14(i,Nx) F15(i,Nx) F16(i,Nx) F17(i,Nx) F18(i,Nx) Fs1(i,Nx) Fs2(i,Nx) Fs3(i,Nx) Fs4(i,Nx)];
   %--Find the maxfluxes out. (4.2.3) 
   for l = 1:18
      if bout(l) <= .5
        b(l) = bout(l) -bout(l)^2;
   else
       b(l) = 1/4;
      end
   end
   %--Find the maxfluxes out sideroads. (4.2.3)
   for l = 19:22
      if bout(l) <= 1/4
        b(l) = bout(l) -2*bout(l)^2;
   else
       b(l) = 1/8;
      end
   end
   bin(1:22) = [F1(i,1) F2(i,1) F3(i,1) F4(i,1) F5(i,1) F6(i,1) F7(i,1) F8(i,1) F9(i,1) F10(i,1) F11(i,1) F12(i,1) F13(i,1) F14(i,1) F15(i,1) F16(i,1) F17(i,1) F18(i,1) Fs1(i,1) Fs2(i,1) Fs3(i,1) Fs4(i,1)];
   %--Find the maxfluxes in (4.2.2)
   for L = 1:18
   if bin(L) <= .5
       a(L) = 1/4;
   else
       a(L) = bin(L)-bin(L)^2;
   end
   end
   %--Find the maxfluxes in sideroads. (4.2.2)
   for L = 19:22
   if bin(L) <= 1/4
       a(L) = 1/8;
   else
       a(L) = bin(L)-2*bin(L)^2;
   end
   end
   %--Find the fluxes in and out for each junction.--
   %Junctions with 2 insomming, 1 outgoing (4 junctions)
   %Junction(3,s2 -> 2) 
   In2 = min(b(3)+ b(20),a(2));
   Out3 = b(3);
   Outs2 = b(20);
   if b(3) + b(20) > a(2) % Amount of cars exceeds C
   Out3 = q*In2;
   Outs2 =(1-q)*In2;
   if Out3 > b(3)         % if p is outside omega
   Out3 = b(3);
   Outs2 = In2 - b(3);
   elseif Outs2 > b(20)  % if p is outside omega (other side)
   Outs2 = b(20);
   Out3 = In2 -b(20);
   end
   end
   %Junction(7,s1 -> 9) 2 out, 1 in
   In9 = min(b(7)+ b(19),a(9));
   Out7 = b(7);
   Outs1= b(19);
   if b(7) + b(19) > a(19) %(Amount of cars exceeds C)
   Out7 = q*In9;
   Outs1 =(1-q)*In9;
   if Out7 > b(7)   % if p lies outside omega.
   Out7 = b(7);
   Outs1 = In9 - b(7);
   elseif Outs1 > b(19)  % if p lies outside omega. (other side)
   Outs1 = b(19);
   Out7 = In9 -b(19);
   end
   end
   %Junction (12,s3 -> 11)
   In11 = min(b(12)+ b(21),a(11));
   Out12 = b(12);
   Outs3 = b(21);
   if b(12)+b(21) > a(11) %Amount of cars exceeds C.
   Out12 = q*In11;
   Outs3 =(1-q)*In11; 
   if Out12 > b(12)  % if p lies outside omega. 
   Out12 = b(12);
   Outs3 = In11 - b(12);
   elseif Outs3 > b(21) % if p lies outside omega (other side).
   Outs3 = b(21);
   Out12 = In11 -b(21);
   end
   end
   %Junction (15,s4 -> 17) 
   In17 = min(b(15)+ b(22),a(17));
   Out15 = b(15);
   Outs4 = b(22);
   if b(15) + b(22) > a(17)%(Amount of cars exceeds C)
   Out15 = q*In17;
   Outs4 =(1-q)*In17;
   if Out15 > b(15)        % if p lies outside gamma.
   Out15 = b(15);
   Outs4 = In17 - b(15);
   elseif Outs4 > b(22)   % if p lies outside gamma (other side)
   Outs4 = b(22);
   Out15 = In17 -b(22);
   end
   end
   % Junction with 1 incomming and 2 outgoing (4 junctions).
   %Junction (5 -> s1,6) 
   In6  = min(alpha1*b(5),a(6));
   Ins1 = min(alpha2*b(5),a(19));
   Out5 = In6 + Ins1;
   %Junction (9 -> s3,10)
   In10  = min(alpha1*b(9),a(10));
   Ins3  = min(alpha2*b(9),a(21));
   Out9  = In10 + Ins3;
   %Junction(13 -> s4,14) 
   In14  = min(alpha1*b(13),a(14));
   Ins4  = min(alpha2*b(13),a(22));
   Out13 = In14 + Ins4;
   %Junction(18 -> s2,16)
   In16  = min(alpha1*b(18),a(16));
   Ins2  = min(alpha2*b(18),a(20));
   Out18 = In16 + Ins2;
   %-------------- Junction with 6 roads (2 junctions)-----------
   %Junction (1,6,8 --> 3,4,7)
   flux1= A*[b(1) ; b(6) ; b(8)];
   In3 = min(flux1(1),a(3));
   In7 = min(flux1(2),a(7));
   In4 = min(flux1(3),a(4));
   if flux1(1) > a(3)
       v(1,1) = flux1(1)-a(3);
   end
   if flux1(2) > a(7)
       v(2,1) = flux1(2)-a(7);
   end
   if flux1(3) > a(4)
       v(3,1) = flux1(3)-a(4);
   end
   %Right of way parameters(Using matrix A)
   Out1 = b(1)-A(1,:)*v;
   Out6 = b(6)-A(2,:)*v;
   Out8 = b(8)-A(3,:)*v;
   %Junction (10,14,16 --> 8,12,15)
   flux2 = A*[b(10) ; b(14) ; b(16)];
   In8  = min(flux2(1),a(8));
   In15 = min(flux2(2),a(15));
   In12 = min(flux2(3),a(12));
   if flux2(1) > a(8)
       v2(1,1) = flux2(1)-a(8);
   end
   if flux2(2) > a(15)
       v2(2,1) = flux2(2)-a(15);
   end
   if flux2(3) > a(12)
       v2(3,1) = flux2(3)-a(12);
   end
   %Right of way parameters(Using matrix A)
   Out10 = b(10)-A(1,:)*v2;
   Out14 = b(14)-A(2,:)*v2;
   Out16 = b(16)-A(3,:)*v2;    
   %--Boundaries--
   %Incomming roads [F1, F5, F13, F18]
   F1(i+1,1) = F1(i,1) -(k/h)*((U1(i,1)-U1(i,1)^2)-(U01-(U01)^2));
   F5(i+1,1) = F5(i,1) -(k/h)*((U5(i,1)-U5(i,1)^2)-(U05-(U05)^2));
   F13(i+1,1) = F13(i,1) -(k/h)*((U13(i,1)-U13(i,1)^2)-(U013-(U013)^2));
   F18(i+1,1) = F18(i,1) -(k/h)*((U18(i,1)-U18(i,1)^2)-(U018-(U018)^2));
   %Roads with outgoing fluxes [All except: F2, F4, F11, F17]
   F1(i+1,Nx)  = F1(i,Nx)  -(k/h)*(Out1-(U1(i,Nx-1)-U1(i,Nx-1)^2));
   F3(i+1,Nx)  = F3(i,Nx)  -(k/h)*(Out3-(U3(i,Nx-1)-U3(i,Nx-1)^2));
   F5(i+1,Nx)  = F5(i,Nx)  -(k/h)*(Out5-(U5(i,Nx-1)-U5(i,Nx-1)^2));
   F6(i+1,Nx)  = F6(i,Nx)  -(k/h)*(Out6-(U6(i,Nx-1)-U6(i,Nx-1)^2));
   F7(i+1,Nx)  = F7(i,Nx)  -(k/h)*(Out7-(U7(i,Nx-1)-U7(i,Nx-1)^2));
   F8(i+1,Nx)  = F8(i,Nx)  -(k/h)*(Out8-(U8(i,Nx-1)-U8(i,Nx-1)^2));
   F9(i+1,Nx)  = F9(i,Nx)  -(k/h)*(Out9-(U9(i,Nx-1)-U9(i,Nx-1)^2));
   F10(i+1,Nx) = F10(i,Nx) -(k/h)*(Out10-(U10(i,Nx-1)-U10(i,Nx-1)^2));
   F12(i+1,Nx) = F12(i,Nx) -(k/h)*(Out12-(U12(i,Nx-1)-U12(i,Nx-1)^2));
   F13(i+1,Nx) = F13(i,Nx) -(k/h)*(Out13-(U13(i,Nx-1)-U13(i,Nx-1)^2));
   F14(i+1,Nx) = F14(i,Nx) -(k/h)*(Out14-(U14(i,Nx-1)-U14(i,Nx-1)^2));
   F15(i+1,Nx) = F15(i,Nx) -(k/h)*(Out15-(U15(i,Nx-1)-U15(i,Nx-1)^2));
   F16(i+1,Nx) = F16(i,Nx) -(k/h)*(Out16-(U16(i,Nx-1)-U16(i,Nx-1)^2));
   F18(i+1,Nx) = F18(i,Nx) -(k/h)*(Out18-(U18(i,Nx-1)-U18(i,Nx-1)^2));
   Fs1(i+1,Nx) = Fs1(i,Nx) -(k/h)*(Outs1-(Us1(i,Nx-1)-2*Us1(i,Nx-1)^2));
   Fs2(i+1,Nx) = Fs2(i,Nx) -(k/h)*(Outs2-(Us2(i,Nx-1)-2*Us2(i,Nx-1)^2));
   Fs3(i+1,Nx) = Fs3(i,Nx) -(k/h)*(Outs3-(Us3(i,Nx-1)-2*Us3(i,Nx-1)^2));
   Fs4(i+1,Nx) = Fs4(i,Nx) -(k/h)*(Outs4-(Us4(i,Nx-1)-2*Us4(i,Nx-1)^2));
   %Roads with incomming fluxes [All except 1,5,13,18]
   F2(i+1,1)   = F2(i,1)  -(k/h)*((U2(i,1)-U2(i,1)^2)-In2);
   F3(i+1,1)   = F3(i,1)  -(k/h)*((U3(i,1)-U3(i,1)^2)-In3);
   F4(i+1,1)   = F4(i,1)  -(k/h)*((U4(i,1)-U4(i,1)^2)-In4);
   F6(i+1,1)   = F6(i,1)  -(k/h)*((U6(i,1)-U6(i,1)^2)-In6);
   F7(i+1,1)   = F7(i,1)  -(k/h)*((U7(i,1)-U7(i,1)^2)-In7);
   F8(i+1,1)   = F8(i,1)  -(k/h)*((U8(i,1)-U8(i,1)^2)-In8);
   F9(i+1,1)   = F9(i,1)  -(k/h)*((U9(i,1)-U9(i,1)^2)-In9);
   F10(i+1,1)  = F10(i,1) -(k/h)*((U10(i,1)-U10(i,1)^2)-In10);
   F11(i+1,1)  = F11(i,1) -(k/h)*((U11(i,1)-U11(i,1)^2)-In11);
   F12(i+1,1)  = F12(i,1) -(k/h)*((U12(i,1)-U12(i,1)^2)-In12);
   F14(i+1,1)  = F14(i,1) -(k/h)*((U14(i,1)-U14(i,1)^2)-In14);
   F15(i+1,1)  = F15(i,1) -(k/h)*((U15(i,1)-U15(i,1)^2)-In15);
   F16(i+1,1)  = F16(i,1) -(k/h)*((U16(i,1)-U16(i,1)^2)-In16);
   F17(i+1,1)  = F17(i,1) -(k/h)*((U17(i,1)-U17(i,1)^2)-In17);
   Fs1(i+1,1)  = Fs1(i,1) -(k/h)*((Us1(i,1)-2*Us1(i,1)^2)-Ins1);
   Fs2(i+1,1)  = Fs2(i,1) -(k/h)*((Us2(i,1)-2*Us2(i,1)^2)-Ins2);
   Fs3(i+1,1)  = Fs3(i,1) -(k/h)*((Us3(i,1)-2*Us3(i,1)^2)-Ins3);
   Fs4(i+1,1)  = Fs4(i,1) -(k/h)*((Us4(i,1)-2*Us4(i,1)^2)-Ins4);
   %Outgoing Roads [F2, F4, F11, F17]
   F2(i+1,Nx)  = F2(i+1,Nx-1);
   F4(i+1,Nx)  = F4(i+1,Nx-1);
   F11(i+1,Nx) = F11(i+1,Nx-1);
   F17(i+1,Nx) = F17(i+1,Nx-1);
end